      program tasks
      include 'mpif.h'
      integer err,rank,size
      integer i,status(MPI_STATUS_SIZE)
      integer num,who
      integer value(3)
      data value/10,5,33/
      call MPI_INIT(err)
      call MPI_COMM_RANK(MPI_COMM_WORLD,rank,err)
      call MPI_COMM_SIZE(MPI_COMM_WORLD,size,err)
      if (rank .eq. 3) then
        do i=1,3
          call MPI_RECV(num,1,MPI_INTEGER,MPI_ANY_SOURCE,88,
     &             MPI_COMM_WORLD,status,err)
          who=status(MPI_SOURCE)
          if (who .eq. 0) then
            call raise(num)
          else if (who .eq. 1) then
            call fac(num)
          else 
            call summer(num)
          end if
        end do
      else
        num=value(rank+1)
        call MPI_SEND(num,1,MPI_INTEGER,3,88,MPI_COMM_WORLD,err)
      end if
      call MPI_FINALIZE(err)
      end

      subroutine raise(x)
        integer x
        print *,"2 to the ",x,"power =",2**x
        return
      end 

      subroutine fac(x)
        integer x,i,res    
        res=1
        do i=1,x
          res=res*i
        end do
        print *,"The factorial of",x,"is",res
        return
      end 

      subroutine summer(x)
        integer x,res
        res=x*(x+1)/2
        print *,"The sum of the integers up to",x,"is",res
        return
      end 
 
