        program interleave 
        include 'mpif.h'
        integer err,rank,size
        integer i,status(MPI_STATUS_SIZE)
        real ism(40),sum
        call MPI_INIT(err)
        call MPI_COMM_RANK(MPI_COMM_WORLD,rank,err)
        call MPI_COMM_SIZE(MPI_COMM_WORLD,size,err)
        call MPI_TYPE_VECTOR(20,1,2,MPI_REAL,weave_type,err)
        call MPI_TYPE_COMMIT(weave-type,err)
        do i=1,40
          ism(i)=0.0
        end do 
        if (rank.eq.0) then
          do i=1,40
            ism(i)=i**2.5
          end do
          call MPI_SEND(ism(2),1,weave_type,2,1701,
     &      MPI_COMM_WORLD,err)
          call MPI_SEND(ism(1),1,weave_type,1,1701,
     &      MPI_COMM_WORLD,err)
        else
          call MPI_RECV(ism,1,weave_type,0,1701,
     &             MPI_COMM_WORLD,status,err)  
          sum=0.0
          do i=1,40
            sum=sum+ism(i)
          end do
          if(rank.eq.1) then
            print *,"P:",rank,"The average of the odd elements is",
     &                  sum/20.0
          else
            print *,"P:",rank,"The average of the even elements is",
     &                  sum/20.0
          end if
        end if
        call MPI_FINALIZE(err)
        end

