      program normalize
      include 'mpif.h'
      integer err,rank,size
      integer status(MPI_STATUS_SIZE)
      integer i,x,hold(8),max
      real norm,sum
      data hold/-27,-4,31,16,20,13,49,1/
      call MPI_INIT(err)
      call MPI_COMM_RANK(MPI_COMM_WORLD,rank,err)
      call MPI_COMM_SIZE(MPI_COMM_WORLD,size,err)
      x=hold(rank+1)
      call MPI_REDUCE(x,max,1,MPI_INTEGER,MPI_MAX,5,MPI_COMM_WORLD,err)
      if (rank.eq.5) then
        do i=0,7
          call MPI_SEND(max,1,MPI_INTEGER,i,359,MPI_COMM_WORLD,err)
        end do
      end if
      call MPI_RECV(max,1,MPI_INTEGER,5,359,MPI_COMM_WORLD,status,err)
      norm=x/(1.0*max) 
      sum=0.0
      call MPI_REDUCE(norm,sum,1,MPI_REAL,MPI_SUM,2,MPI_COMM_WORLD,err)
      if (rank.eq.2) then
        print *,"P:",rank,"normalized sum is",sum
      end if 
      call MPI_FINALIZE(err)
      end 
